/*
 * PyJaMaS
 *
 * Copyright (c) 2006
 *	Jiri Svoboda
 *	portions from Kalisto
 * see ../README for more details
 */
  
 /** \file
 * Simple round-robin thread scheduler with suspending.
 */


#ifndef _SCHED_H_
#define _SCHED_H_

#include "thread.h"

/**
 * Init the scheduler module.
 */
void sched_init (struct thread_struct *t);

/**
 * Mark the thread as ready to run and add it to the ready-to-run list.
 */
void sched_add_runnable_thread (struct thread_struct *t);


/**
 * Schedule the next thread.
 */
 void schedule (void);

/**
 * Move the thread from runnable list to sleeping list.
 */
 void sched_sleep_thread (struct thread_struct *t);

/**
 * Move the thread from sleeping list to runnable list.
 */
 void sched_unsleep_thread (struct thread_struct *t);

/**
 * Remove the thread from either runnable list or sleeping list.
 */
 void sched_remove_thread (struct thread_struct *t);

#endif /* _SCHED_H_ */
